//---------------------------------------------------------------------------

#include <vcl.h>
#include <mmsystem.h>
#include <algorithm>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;

const UINT baseTick = 180;
const int MAX_X = 32;
const int MAX_Y = 32;

const TColor TMainForm::chColor[] = {
    clWhite,
    clBlue,
    clRed,
    clGreen,
    clLime,
    clPurple,
    clFuchsia,
    clOlive,
    clYellow,
};
//---------------------------------------------------------------------------
TGridItem::TGridItem(int x, int y) :
    maxx(x), maxy(y)
{
    note = new int[x * y];
    for (int i = 0; i < x * y; i++)
    {
        *(note + i) = 0;
    }
}
//---------------------------------------------------------------------------
TGridItem::~TGridItem()
{
    delete[] note;
}
//---------------------------------------------------------------------------
void TGridItem::Load(HANDLE h)
{
    DWORD dw;
    if (ReadFile(h, note, maxx * maxy * sizeof(int), &dw, NULL) && dw > 0)
    {
        for (DWORD i = 0; i < dw / sizeof(int); i++)
        {
            *(note + i) = abs(*(note + i) % COUNTOF(TMainForm::chColor));
        }
    }
}
//---------------------------------------------------------------------------
void TGridItem::Save(HANDLE h)
{
    DWORD dw;
    WriteFile(h, note, maxx * maxy * sizeof(int), &dw, NULL);
}
//---------------------------------------------------------------------------
void (CALLBACK TimerEvent)(UINT uTimerID, UINT uMsg, DWORD_PTR dwUser, DWORD_PTR dw1, DWORD_PTR dw2)
{
    TMainForm* pThis = reinterpret_cast<TMainForm*>(dwUser);
    pThis->BaseLine();
}
//---------------------------------------------------------------------------

BYTE TMainForm::Abase1[][12] = {
        { 0x01, 0x9a, 36, 80,
          0, 0x90, 36, 127,
          0, 0x80, 31, 127, },
        { 0x01, 0x8a, 36, 127,
          0, 0x90, 31, 127,
          0, 0x80, 36, 127, },
};
BYTE TMainForm::Abase2[][12] = {
        { 0x01, 0x9a, 40, 80,
          0, 0x90, 40, 127,
          0, 0x80, 31, 127, },
        { 0x01, 0x8a, 40, 127,
          0, 0x90, 31, 127,
          0, 0x80, 40, 127, },
};

//
// {̓NeBJZNV͕svA[JXbhBaseLinesƂ̂߂ɎB
//
void TMainForm::BaseLine()
{
    static DWORD base1[][8] = {
        { MAKEFOURCC( 0x9a, 36, 80, 0), MAKEFOURCC( 0x90, 36, 127, 0), MAKEFOURCC( 0x80, 31, 127, 0), 0 },
        { MAKEFOURCC( 0x8a, 36, 127, 0), MAKEFOURCC( 0x90, 31, 127, 0), MAKEFOURCC( 0x80, 36, 127, 0), 0 },
    };
    static DWORD base2[][8] = {
        { MAKEFOURCC( 0x9a, 40, 80, 0), MAKEFOURCC( 0x90, 40, 127, 0), MAKEFOURCC( 0x80, 31, 127, 0), 0 },
        { MAKEFOURCC( 0x8a, 40, 127, 0), MAKEFOURCC( 0x90, 31, 127, 0), MAKEFOURCC( 0x80, 40, 127, 0), 0 },
    };
    static int prevCount = 0;
    static BYTE prevCh[MAX_Y];
    static BYTE prevT[MAX_Y];
    
    int s(baseNote % 2);
    DWORD* p = (baseCycle < 8) ? base1[s] : base2[s];
    while (*p)
        midiOutShortMsg(hMIDI, *p++);
    if (midiStrm)
    {
        crit->Acquire();
        if (midiStrm == NULL)
        {
            crit->Leave();
        }
        else
        {
            BYTE* p = (baseCycle < 8) ? Abase1[s] : Abase2[s];
            midiStrm->Write(p, 12);
        }
    }

    BYTE buff[4];
    buff[0] = 0;
    int bufflen;
    if (s == 0)
    {
        long lLast(0);
        int ch;
        for (int mp = 0; mp < prevCount; mp++)
        {
            buff[3] = 0;
            ch = prevCh[mp] | 0x80;
            if (lLast == ch)
            {
                midiOutShortMsg(hMIDI, MAKEFOURCC(prevT[mp], 0, 0, 0));
                bufflen = 3;
            }
            else
            {
                midiOutShortMsg(hMIDI, MAKEFOURCC(ch, prevT[mp], 0, 0));
                bufflen = 4;
                lLast = ch;
            }
            if (midiStrm)
            {
                if (bufflen == 4)
                {
                    buff[1] = ch;
                    buff[2] = prevT[mp];
                }
                else
                {
                    buff[1] = prevT[mp];
                    buff[2] = 0;
                }
                midiStrm->Write(buff, bufflen);
            }
        }
        prevCount = 0;
        TGridItem* item = items[currItem];
        long lCurr;
        for (int i = 0; i < item->maxy; i++)
        {
            int ht(abs(i - item->maxy + 1));
            int t(36 + ht / 7 * 12);
            static const int to[] = {0, 2, 4, 5, 7, 9, 11 };
            t += to[ht % 7];
            buff[3] = 127;
            if ((ch = item->getPoint(midCycle, i)) != 0)
            {
                prevCh[prevCount] = ch;
                prevT[prevCount++] = t;
                lCurr = 0x90 | ch;
                if (lCurr == lLast)
                {
                    midiOutShortMsg(hMIDI, MAKEFOURCC(t, 127, 0, 0));
                    bufflen = 3;
                }
                else
                {
                    midiOutShortMsg(hMIDI, MAKEFOURCC(lCurr, t, 127, 0));
                    lLast = lCurr;
                    bufflen = 4;
                }
                if (midiStrm)
                {
                    if (bufflen == 4)
                    {
                        buff[1] = (BYTE)lCurr;
                        buff[2] = t;
                    }
                    else
                    {
                        buff[1] = t;
                        buff[2] = 127;
                    }
                    midiStrm->Write(buff, bufflen);
                }
            }
        }
        PostMessage(Handle, WM_APP, midCycle, 0);
        midCycle++;
        if (midCycle >= item->maxx)
            midCycle = 0;

    }
    if (midiStrm)
    {
        crit->Leave();
    }
    baseNote ^= 1;
    baseCycle++;
    if (baseCycle >= 16)
        baseCycle = 0;
}
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner), hMIDI((HMIDIOUT)INVALID_HANDLE_VALUE), baseCycle(0), baseNote(0),
      timerID(NULL), midCycle(0), currChannel(1), currentColor(StaticText1),
      uiTick(baseTick), uiRes(10), currItem(0),
      h(Image1->Height / MAX_X), w(Image1->Width / MAX_Y),
      xmax(Image1->Width / w), xmid(xmax / 2),
      ymax(Image1->Height / h), ymid(ymax / 2),
      midiStrm(NULL)
{
    crit = new TCriticalSection;
    for (int i = 0; i < COUNTOF(items); i++)
        items[i] = new TGridItem(MAX_X, MAX_Y);

    TRect rect;
    rect.Top = 1;
    rect.left = 1;
    rect.Bottom = ImageS1->Height - 1;
    rect.Right = ImageS1->Width - 1;
    canvases[0] = ImageS1->Canvas;
    canvases[1] = ImageS2->Canvas;
    canvases[2] = ImageS3->Canvas;
    canvases[3] = ImageS4->Canvas;
    canvases[4] = ImageS5->Canvas;
    canvases[5] = ImageS6->Canvas;
    canvases[6] = ImageS7->Canvas;
    canvases[7] = ImageS8->Canvas;
    for (int i = 0; i < COUNTOF(canvases); i++)
    {
        canvases[i]->FillRect(rect);
    }
    DrawGrid();
    DrawFocus(ImageS1->Canvas);

    HRESULT hr = midiOutOpen(&hMIDI, MIDI_MAPPER, NULL, NULL, CALLBACK_NULL);
    if (hr != MMSYSERR_NOERROR)
    {
        hMIDI = (HMIDIOUT)INVALID_HANDLE_VALUE;
    }
    else
    {
        midiOutShortMsg(hMIDI, MAKEFOURCC(0xc0, 35, 0, 0));
        midiOutShortMsg(hMIDI, MAKEFOURCC(0xca, 104, 0, 0));
        //
        midiOutShortMsg(hMIDI, MAKEFOURCC(0xc1, 3, 0, 0));
        midiOutShortMsg(hMIDI, MAKEFOURCC(0xc2, 18, 0, 0));
        midiOutShortMsg(hMIDI, MAKEFOURCC(0xc3, 28, 0, 0));
        midiOutShortMsg(hMIDI, MAKEFOURCC(0xc4, 55, 0, 0));
        midiOutShortMsg(hMIDI, MAKEFOURCC(0xc5, 104, 0, 0));
        midiOutShortMsg(hMIDI, MAKEFOURCC(0xc6, 115, 0, 0));
        midiOutShortMsg(hMIDI, MAKEFOURCC(0xc7, 107, 0, 0));
        midiOutShortMsg(hMIDI, MAKEFOURCC(0xc8, 56, 0, 0));
    }

	TIMECAPS tc;
	MMRESULT mr = timeGetDevCaps(&tc, sizeof(TIMECAPS));
	if (mr == TIMERR_NOERROR)
	{
    	uiRes = min(max(tc.wPeriodMin, (UINT)10), tc.wPeriodMax);
    }
    timeBeginPeriod(uiRes);
    timerID = timeSetEvent(uiTick, uiRes, TimerEvent, (DWORD)this, TIME_PERIODIC);

}
//---------------------------------------------------------------------------
void TMainForm::DrawGrid(bool point)
{
    TCanvas* p = Image1->Canvas;
    TRect rect;
    rect.Top = 0;
    rect.left = 0;
    rect.Bottom = Image1->Height;
    rect.Right = Image1->Width;
    p->Brush->Color = chColor[0];
    p->FillRect(rect);
    p->Pen->Color = clBlack;
    p->Pen->Width = 1;
    TGridItem* item = items[currItem];
    for (int x = 0; x < xmax; x++)
    {
        if (x == xmid)
            p->Pen->Width = 2;
        p->MoveTo(x * w, 0);
        p->LineTo(x * w, Image1->Height);
        if (x == xmid)
            p->Pen->Width = 1;
    }

    for (int y = 0; y < ymax; y++)
    {
        if (y == ymid)
             p->Pen->Width = 2;
        p->MoveTo(0, y * h);
        p->LineTo(Image1->Width, y * h);
        if (y == ymid)
            p->Pen->Width = 1;
    }
    rect.Top = 1;
    rect.left = 1;
    rect.Bottom = ImageS1->Height - 1;
    rect.Right = ImageS1->Width - 1;
    canvases[currItem]->Brush->Color = clWhite;
    canvases[currItem]->FillRect(rect);

    if (point)
    {
        for (int y = 0; y < item->maxy; y++)
        {
            for (int x = 0; x < item->maxx; x++)
            {
                int ch = item->getPoint(x, y);
                if (ch)
                {
                    TRect tr;
                    tr.Left = x * w + 1;
                    tr.top = y * h + 1;
                    tr.Bottom = (y + 1) * h - ((y == ymid) ? 1 : 0);
                    tr.Right = (x + 1) * w - ((x == xmid) ? 1 : 0);
                    p->Brush->Color = chColor[ch];
                    p->Ellipse(tr);
                    canvases[currItem]->Pen->Color = chColor[ch];
                    canvases[currItem]->MoveTo(x + 1, y + 1);
                    canvases[currItem]->LineTo(x + 2, y + 2);
                }
            }
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DrawFocus(TCanvas* p, bool lost)
{
    if (lost)
        p->Brush->Color = Panel2->Color;
    else
        p->Brush->Color = clBlack;
    TRect rect;
    rect.Top = 0;
    rect.left = 0;
    rect.Bottom = ImageS1->Height;
    rect.Right = ImageS1->Width;
    p->FrameRect(rect);
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
    //TODO: ̉ɃR[hǉĂ
    if (timerID)
    {
        timeKillEvent(timerID);
        timerID = NULL;
    }
    timeEndPeriod(uiRes);
    if (hMIDI != (HMIDIOUT)INVALID_HANDLE_VALUE)
    {
        int cb(0);
        HRESULT hr;
        do
        {
            hr = midiOutClose(hMIDI);
            if (hr == MIDIERR_STILLPLAYING)
            {
                midiOutReset(hMIDI);
            }
            else if (hr != MMSYSERR_NOERROR)
            {
                Sleep(100);
                cb++;
            }
        }
        while (hr != MMSYSERR_NOERROR && cb < 8);
        hMIDI = (HMIDIOUT)INVALID_HANDLE_VALUE;
    }
    for (int i = 0; i < COUNTOF(items); i++)
    {
        delete items[i];
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Image1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Button == mbLeft)
    {
        TGridItem* item = items[currItem];
        TCanvas* p = Image1->Canvas;
        int y(Y / h);
        int x(X / w);
        TRect tr;
        tr.Left = x * w + 1;
        tr.top = y * h + 1;
        tr.Bottom = (y + 1) * h - ((y == ymid) ? 1 : 0);
        tr.Right = (x + 1) * w - ((x == xmid) ? 1 : 0);
        int old = item->getPoint(x, y);
        int chnl = (old) ? 0 : currChannel;
        item->setPoint(x, y, chnl);
        p->Brush->Color = chColor[chnl];
        if (old)
            p->FillRect(tr);
        else
            p->Ellipse(tr);
        canvases[currItem]->Pen->Color = chColor[chnl];
        canvases[currItem]->MoveTo(x + 1, y + 1);
        canvases[currItem]->LineTo(x + 2, y + 2);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ActionFileNewExecute(TObject *Sender)
{
    midiOutReset(hMIDI);
    TGridItem* item = items[currItem];
    for (int y = 0; y < item->maxy; y++)
    {
        for (int x = 0; x < item->maxx; x++)
        {
            item->setPoint(x, y, 0);
        }
    }
    DrawGrid(true);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ActionFileOpenExecute(TObject *Sender)
{
	if (OpenDialog->Execute())
	{
        midiOutReset(hMIDI);
        HANDLE h = CreateFile(OpenDialog->FileName.c_str(), GENERIC_READ, FILE_SHARE_READ,
            NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
        if (h != INVALID_HANDLE_VALUE)
        {
            items[currItem]->Load(h);
            CloseHandle(h);
            DrawGrid(true);
        }
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CreateMidi(HANDLE h)
{
    DWORD dw;
    unsigned char buff[16384];
    WriteFile(h, "MThd\0\0\0\x06\0\0\0\x01\0\x04", 14, &dw, NULL);
    WriteFile(h, "MTrk\0\0\0\0", 8, &dw, NULL);
    DWORD dwPoint = SetFilePointer(h, 0, NULL, FILE_CURRENT);
    static const BYTE bTrackOne[] = {
        0, 0xc0, 35,
        0, 0xca, 104,
        //
        0, 0xc1, 3,
        0, 0xc2, 18,
        0, 0xc3, 28,
        0, 0xc4, 55,
        0, 0xc5, 104,
        0, 0xc6, 115,
        0, 0xc7, 107,
        0, 0xc8, 56,
    };
    WriteFile(h, &bTrackOne[0], sizeof(bTrackOne), &dw, NULL);

    DWORD dwTemp = TrackBar->Position + baseTick;
    dwTemp *= 4000;
    buff[0] = 0;
    buff[1] = (BYTE)0xff;
    buff[2] = 0x51;
    buff[3] = 0x3;
    buff[4] = (BYTE)(dwTemp >> 16);
    buff[5] = (BYTE)(dwTemp >> 8);
    buff[6] = (BYTE)dwTemp;
    WriteFile(h, buff, 7, &dw, NULL);

    int buffi = 0;
    for (int x = 0, base = 0; x < MAX_X; x++)
    {
        int s(x % 2);
        BYTE* p = (base < 8) ? Abase1[s] : Abase2[s];
        memcpy(&buff[buffi], p, 12);
        buffi += 12;
        if (!s)
        {
            TGridItem* item = items[currItem];
            int prv = x - 1;
            long lLast(0);
            long lCurr;
            for (int i = 0; i < item->maxy; i++)
            {
                int ht(abs(i - item->maxy + 1));
                int t(36 + ht / 7 * 12);
                int ch;
                static const int to[] = {0, 2, 4, 5, 7, 9, 11 };
                t += to[ht % 7];

                if (prv >= 0)
                {
                    ch = item->getPoint(prv, i);
                    if (ch)
                    {
                        lCurr = 0x80 | ch;
                        buff[buffi++] = 0;
                        if (lCurr == lLast)
                        {
                            buff[buffi++] = (BYTE)t;
                            buff[buffi++] = 0;
                        }
                        else
                        {
                            buff[buffi++] = (BYTE)lCurr;
                            buff[buffi++] = (BYTE)t;
                            buff[buffi++] = 0;
                            lLast = lCurr;
                        }
                    }
                }

                if ((ch = item->getPoint(x, i)) != 0)
                {
                    lCurr = 0x90 | ch;
                    buff[buffi++] = 0;
                    if (lCurr == lLast)
                    {
                        buff[buffi++] = (BYTE)t;
                        buff[buffi++] = 127;
                    }
                    else
                    {
                        buff[buffi++] = (BYTE)lCurr;
                        buff[buffi++] = (BYTE)t;
                        buff[buffi++] = 127;
                        lLast = lCurr;
                    }
                }
            }
        }
        base++;
        if (base >= 16)
            base = 0;
    }
    buff[buffi++] = 0;
    buff[buffi++] = 0xff;
    buff[buffi++] = 0x2f;
    buff[buffi++] = 0;
    WriteFile(h, buff, buffi, &dw, NULL);
    DWORD dwLast = SetFilePointer(h, 0, NULL, FILE_CURRENT);
    SetFilePointer(h, dwPoint - 4, NULL, FILE_BEGIN);
    dwLast -= dwPoint;
    buff[0] = (BYTE)(dwLast >> 24);
    buff[1] = (BYTE)(dwLast >> 16);
    buff[2] = (BYTE)(dwLast >> 8);
    buff[3] = (BYTE)(dwLast);
    WriteFile(h, buff, sizeof(DWORD), &dw, NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ActionFileSaveExecute(TObject *Sender)
{
    SaveDialog->Filter = "MIDORION File|*.MOR|MIDI File|*.mid|SẴt@C|*.*";
    if (SaveDialog->Execute())
    {
        AnsiString& fname = SaveDialog->FileName;
        int ps = fname.LastDelimiter(".");
        AnsiString ext = fname.SubString(ps, fname.Length() - ps + 1).UpperCase();
        HANDLE h = CreateFile(fname.c_str(), GENERIC_WRITE, FILE_SHARE_READ,
            NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
        if (h != INVALID_HANDLE_VALUE)
        {
            if (ext.AnsiPos(".MID") > 0)
            {
                CreateMidi(h);
            }
            else
            {
                items[currItem]->Save(h);
            }
            CloseHandle(h);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StaticText1Click(TObject *Sender)
{
    TStaticText* p = (TStaticText*)Sender;
    TColor cl = p->Color;
    for (int i = 0; i < COUNTOF(chColor); i++)
    {
        if (chColor[i] == cl)
        {
            if (currChannel != i)
            {
                p->BorderStyle = sbsSunken;
                currentColor->BorderStyle = sbsNone;
                currChannel = i;
                currentColor = p;
            }
            break;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ActionExitExecute(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------


LRESULT TMainForm::OnDrawTick(TMessage msg)
{
    //TODO: ̉ɃR[hǉĂ
    TCanvas* p = Image1->Canvas;
    TGridItem* item = items[currItem];
    int prv(msg.WParam - 1);
    if (prv < 0)
        prv = item->maxx - 1;
    for (int y = 0; y < item->maxy; y++)
    {
        TRect tr;
        tr.top = y * h + 1;
        tr.Bottom = (y + 1) * h - ((y == ymid) ? 1 : 0);

        int ch = item->getPoint(prv, y);
        if (ch)
        {
            tr.Left = prv * w + 1;
            tr.Right = (prv + 1) * w - ((prv == xmid) ? 1 : 0);
            p->Brush->Color = chColor[0];
            p->FillRect(tr);
            p->Brush->Color = chColor[ch];
            p->Ellipse(tr);
        }
        if ((ch = item->getPoint(msg.WParam, y)) != 0)
        {
            tr.Left = msg.WParam * w + 1;
            tr.Right = (msg.WParam + 1) * w - ((msg.WParam == xmid) ? 1 : 0);
            p->Brush->Color = chColor[ch];
            p->FillRect(tr);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TrackBarChange(TObject *Sender)
{
    uiTick = TrackBar->Position + baseTick;
    UINT newtimerID = timeSetEvent(uiTick, uiRes, TimerEvent, (DWORD)this, TIME_PERIODIC);
    timeKillEvent(timerID);
    timerID = newtimerID;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ActionCanvasChangedExecute(TObject *Sender)
{
    int next = ((TImage*)Sender)->Tag;
    if (next != currItem)
    {
        DrawFocus(canvases[currItem], true);
        currItem = next;
        DrawFocus(canvases[currItem], false);
        midiOutReset(hMIDI);
        DrawGrid(true);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ActionRecordingExecute(TObject *Sender)
{
    ToolButtonRecording->Action = ActionRecStop;
    midiStrm = new TMemoryStream();
    static const BYTE bTrackOne[] = {
        0, 0xc0, 35,
        0, 0xca, 104,
        //
        0, 0xc1, 3,
        0, 0xc2, 18,
        0, 0xc3, 28,
        0, 0xc4, 55,
        0, 0xc5, 104,
        0, 0xc6, 115,
        0, 0xc7, 107,
        0, 0xc8, 56,
    };
    midiStrm->Write(&bTrackOne[0], sizeof(bTrackOne));
    BYTE buff[8];
    DWORD dwTemp = TrackBar->Position + baseTick;
    dwTemp *= 4000;
    buff[0] = 0;
    buff[1] = (BYTE)0xff;
    buff[2] = 0x51;
    buff[3] = 0x3;
    buff[4] = (BYTE)(dwTemp >> 16);
    buff[5] = (BYTE)(dwTemp >> 8);
    buff[6] = (BYTE)dwTemp;
    midiStrm->Write(buff, 7);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ActionRecStopExecute(TObject *Sender)
{
    crit->Acquire();
    TMemoryStream* ms = midiStrm;
    midiStrm = NULL;
    crit->Leave();
    BYTE buff[4];
    buff[0] = 0;
    buff[1] = 0xff;
    buff[2] = 0x2f;
    buff[3] = 0;
    ms->Write(buff, 4);
    bool write = false;
    SaveDialog->Filter = "MIDI File|*.mid|SẴt@C|*.*";
    do
    {
        write = SaveDialog->Execute();
        if (!write) break;
        try
        {
            TFileStream* fs = new TFileStream(SaveDialog->FileName, fmCreate | fmShareDenyWrite);
            fs->Write("MThd\0\0\0\x06\0\0\0\x01\0\x04", 14);
            fs->Write("MTrk", 4);
            DWORD dwLast = ms->Size;
            buff[0] = (BYTE)(dwLast >> 24);
            buff[1] = (BYTE)(dwLast >> 16);
            buff[2] = (BYTE)(dwLast >> 8);
            buff[3] = (BYTE)(dwLast);
            fs->Write(buff, 4);
            ms->SaveToStream(fs);
            delete fs;
            write = false;
        }
        catch (EStreamError& e)
        {
            write = Application->MessageBox("t@C쐬ɃG[܂", NULL, MB_RETRYCANCEL) == IDRETRY;
        }
    }
    while (write);
    delete ms;
    ToolButtonRecording->Action = ActionRecording;
}
//---------------------------------------------------------------------------

